

zipHarsh :: [a] -> [b] -> [(a,b)]
zipHarsh [] []  =  []
zipHarsh (x:xs) (y:ys)  =  (x,y) : zipHarsh xs ys

dot :: Num a => [a] -> [a] -> a
dot xs ys  =  sum [ x*y | (x,y) <- zipHarsh xs ys ]

dotRec :: Num a => [a] -> [a] -> a
dotRec [] []          =  0
dotRec (x:xs) (y:ys)  =  x*y + dotRec xs ys

brexit = "brexit" : brexit

adj :: [a] -> [(a,a)]
adj xs = zip xs (tail xs)

adj' :: [a] -> [(a,a)]
adj' xs = zip (tail xs) xs


