import Test.QuickCheck

search :: Eq a => [a] -> a -> [Int]
search xs y = [ i | (i,x) <- zip [0..] xs, x==y ]

searchRec :: Eq a => [a] -> a -> [Int]
searchRec xs y  =  srch xs y 0
  where
  srch :: Eq a => [a] -> a -> Int -> [Int]
  srch [] y i      =  []
  srch (x:xs) y i
    | x == y       =  i : srch xs y (i+1)
    | otherwise    =  srch xs y (i+1)

prop_search xs x = search xs x == searchRec xs x
